package de.jatitv.opsecurity.cmdManagement;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.Load;
import de.jatitv.opsecurity.system.Main;
import de.jatitv.opsecurity.system.Permissions;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class Commands {

    public static void mainCommand(CommandSender sender) {
        if (SelectConfig.onlyOpCanUseThePlugin) {
            if (!sender.isOp()) {
                sender.sendMessage(Util.getPrefix() + "§cOnly OPs can use OPSecurity!");
                return;
            }
        }
        if (sender.hasPermission(Permissions.help)) {
            SelectConfig.Help(sender);
        } else {
            sender.sendMessage(Util.getPrefix() + " §cYou do not have permission for OPSecurity! §7<" + Permissions.help + ">");
        }
    }

    public static void reload(CommandSender sender) {
        if (!sender.hasPermission(Permissions.reload)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.reload + ">");
            return;
        }
        if (sender instanceof Player) {
            Player player = (Player) sender;
            if (!Main.getOpHashMap().containsKey(player.getName().toLowerCase())) {
                sender.sendMessage(Util.getPrefix() + " §4You are not on the Whitelist!");
                return;
            }
            if (!Main.getOpHashMap().get(player.getName().toLowerCase()).UUID.equals(player.getUniqueId().toString().replace("-", ""))) {
                sender.sendMessage(Util.getPrefix() + " §4You are not on the Whitelist!");
                return;
            }
            T2Csend.player(player, SelectMessages.ReloadStart);
        }
        if (sender instanceof Player) T2Csend.player((Player) sender, SelectMessages.ReloadEnd);
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §6Plugin reload...");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Load.loadReload();
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §2Plugin successfully reloaded.");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
    }


    public static void info(CommandSender sender) {
        if (!sender.hasPermission(Permissions.info)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.info + ">");
            return;
        }
        T2Ctemplate.sendInfo(sender,Main.getPlugin(),Util.getSpigotID(),Util.getDiscord(),Util.getInfoText());
    }
}
