package de.jatitv.opsecurity.system;

import net.t2code.t2codelib.SPIGOT.api.register.T2Cregister;
import org.bukkit.permissions.PermissionDefault;

public class Permissions {
    public static final String key = "opsecurity.";
    public static final String notify = key + "notify";
    public static final String updatemsg = key + "updatemsg";
    public static final String reload = key + "command.reload";
    public static final String info = key + "command.info";
    public static final String help = key + "command.help";

    public static final String admin = key + "admin";
    public static final PermissionDefault op = PermissionDefault.OP;
    public static final PermissionDefault notOp = PermissionDefault.NOT_OP;

    protected static void register() {
        T2Cregister.permission(notify, op, Main.getPlugin());
        T2Cregister.permissionDescription(notify,"Players with this permission get the update message when joining if an update is available",Main.getPlugin());
        T2Cregister.permission(updatemsg, op, Main.getPlugin());
        T2Cregister.permission(reload, op, Main.getPlugin());
        T2Cregister.permission(info, op, Main.getPlugin());
        T2Cregister.permission(help, op, Main.getPlugin());

        T2Cregister.permission(admin, op, notify, true, Main.getPlugin());
        T2Cregister.permission(admin, op, updatemsg, true, Main.getPlugin());
        T2Cregister.permission(admin, op, reload, true, Main.getPlugin());
        T2Cregister.permission(admin, op, info, true, Main.getPlugin());
        T2Cregister.permission(admin, op, help, true, Main.getPlugin());
    }
}
