// This claas was created by JaTiTV

package de.jatitv.opsecurity.cmdManagement;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.Permissions;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class CmdExecuter implements CommandExecutor, TabCompleter {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 0) {
            Commands.mainCommand(sender);
        } else {
            if (SelectConfig.onlyOpCanUseThePlugin) {
                if (!sender.isOp()) {
                    sender.sendMessage(Util.getPrefix() + "§cOnly OPs can use OPSecurity!");
                    return false;
                }
            }
            switch (args[0].toLowerCase()) {
                case "reload":
                case "rl":
                    Commands.reload(sender);
                    break;
                case "info":
                case "plugin":
                case "pl":
                case "version":
                case "ver":
                    Commands.info(sender);
                    break;
                case "help":
                default:
                    SelectConfig.Help(sender);
                    break;
            }
        }
        return false;
    }

    private static HashMap<String, String> arg1 = new HashMap<String, String>() {{
        put("help", Permissions.help);
        put("reload", Permissions.reload);
        put("info", Permissions.info);
    }};

    @Override
    public List<String> onTabComplete(CommandSender sender, Command cmd, String s, String[] args) {
        List<String> list = new ArrayList<>();
        if (sender instanceof Player) {
            Player p = (Player) sender;
            if (args.length == 1) {
                for (String command : arg1.keySet()) {
                    Boolean passend = true;
                    for (int i = 0; i < args[0].length(); i++) {
                        if (args[0].length() >= command.length()) {
                            passend = false;
                        } else {
                            if (args[0].charAt(i) != command.charAt(i)) {
                                passend = false;
                            }
                        }
                    }
                    if (hasPermission(p, arg1.get(command)) && passend) {
                        list.add(command);
                    }
                }
            }

            if (args.length == 2) {
                switch (args[0]) {
                    case "give":
                        if (hasPermission(p, arg1.get("give"))) {
                            for (Player player : Bukkit.getOnlinePlayers()) {
                                Boolean passend = true;
                                for (int i = 0; i < args[1].length(); i++) {
                                    if (args[1].length() >= player.getName().length()) {
                                        passend = false;
                                    } else {
                                        if (args[1].charAt(i) != player.getName().charAt(i)) {
                                            passend = false;
                                        }
                                    }
                                }
                                if (hasPermission(p, arg1.get(player)) && passend) {
                                    list.add(player.getName());
                                }
                            }
                        }
                        break;
                }
            }
        }
        return list;
    }

    public static boolean hasPermission(Player player, String permission) {
        if (player.isOp()) {
            return true;
        }
        String[] Permissions = permission.split(";");
        for (String perm : Permissions) {
            if (player.hasPermission(perm)) {
                return true;
            }
        }
        return false;
    }
}
