// This claas was created by JaTiTV

package de.jatitv.opsecurity.listener;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.*;
import org.bukkit.scheduler.BukkitRunnable;

public class Events implements org.bukkit.event.Listener {

    @EventHandler
    public void CommandSendEvent(PlayerCommandPreprocessEvent event) {
        if (SelectConfig.checkOnCommand) {
            Player player = event.getPlayer();
            if (Check.onCheck(player, false)) {
                if (event.isCancelled()) return;
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    public void PlayerChatEvent(PlayerChatEvent event) {
        if (SelectConfig.checkOnChat) {
            Player player = event.getPlayer();
            if (Check.onCheck(player, false)) {
                if (event.isCancelled()) return;
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        if (SelectConfig.checkOnInteract) {
            Player player = event.getPlayer();
            new BukkitRunnable() {
                @Override
                public void run() {
                    event.setCancelled(Check.onCheck(player, false));
                }
            }.runTaskLater(Main.getPlugin(), 1L);
        }
    }

    @EventHandler
    public void onJoinCheck(PlayerJoinEvent event) {
        if (SelectConfig.checkOnJoin) {
            Player player = event.getPlayer();
            new BukkitRunnable() {
                @Override
                public void run() {
                    Check.onCheck(player, true);
                }
            }.runTaskLater(Main.getPlugin(), 1L);
        }
    }

    @EventHandler
    public void onJoinEvent(PlayerLoginEvent event) {
        Player player = event.getPlayer();
        T2CupdateAPI.join(Main.getPlugin(), Util.getPrefix(), "opsecurity.updatemsg", player, Util.getSpigotID(), Util.getDiscord());
    }
}
