// This claas was created by JaTiTV

package de.jatitv.opsecurity.system;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.cmdManagement.CmdExecuter;
import de.jatitv.opsecurity.config.config.ConfigConvert;
import de.jatitv.opsecurity.config.config.CreateConfig;
import de.jatitv.opsecurity.config.languages.LanguagesCreate;
import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.listener.Events;
import de.jatitv.opsecurity.listener.OPCommand;
import de.jatitv.opsecurity.listener.PlugManCommand;
import de.jatitv.opsecurity.listener.Timer;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.register.T2Cregister;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;

import java.util.List;

public class Load {
    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2Ctemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        T2CupdateAPI.onUpdateCheck(Main.getPlugin(), prefix, spigotID, discord);
        Metrics.Bstats();
        loadReload();
        Permissions.register();
        Main.getPlugin().getCommand("opsecurity").setExecutor(new CmdExecuter());
        T2Cregister.listener(new Events(), Main.getPlugin());
        T2Cregister.listener(new OPCommand(), Main.getPlugin());
        T2Cregister.listener(new PlugManCommand(), Main.getPlugin());
        T2Ctemplate.onLoadFooter(prefix, long_);
    }

    public static void loadReload() {
        ConfigConvert.convert();
        try {
            CreateConfig.configCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.onSelect();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            LanguagesCreate.messagesCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectMessages.selectCreate(Util.getPrefix());
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.sound();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            Timer.RefreshTimer();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
